#pragma once
#include "../acl_cpp_define.hpp"
#include "../stdlib/string.hpp"
#include "../db/db_handle.hpp"

#if !defined(ACL_DB_DISABLE)

typedef struct sqlite3 sqlite3;
typedef struct sqlite3_stmt sqlite3_stmt;

namespace acl {

class charset_conv;
class sqlite_cursor;

class ACL_CPP_API db_sqlite : public db_handle
{
public:
	/**
	 * 캯
	 * @param charset {const char*} ַ(gbk, utf-8, ...)
	 */
	db_sqlite(const char* dbfile, const char* charset = "utf-8");
	~db_sqlite(void);

	/**
	 * صǰ sqlite İ汾Ϣ
	 */
	const char* version(void) const;

	/**
	 * ݿ򿪺ͨ˺ݿĲã
	 * õҪϸѭ sqlite ѡҪ
	 * @param pragma {const char*} ѡݣʽΪ
	 *  PRAGMA xxx=xxx
	 *  磺PRAGMA synchronous = NORMAL
	 * @return {bool} ݿǷɹ
	 */
	bool set_conf(const char* pragma);

	/**
	 * ݿ򿪵ô˺ѡ
	 * @param pragma {const char*} ѡݣʽΪ
	 *  PRAGMA xxx
	 *  磺PRAGMA synchronous
	 * @param out {string&} ֵǿ洢
	 * @return {const char*} Ϊ˵òڻݿδ
	 */
	const char* get_conf(const char* pragma, string& out);

	/**
	 * ݿ򿪵ݿѡ
	 * @param pragma {const char*} ָѡòΪգ
	 *  еѡʽΪPRAGMA xxx磺PRAGMA synchronous
	 */
	void show_conf(const char* pragma = NULL);

	/**
	 * ݿ򿪺еӰļ¼
	 * @return {int} Ӱ-1 ʾ
	 */
	int affect_total_count(void) const;

	/**
	 * ֱӻ sqlite ľ NULL ʾ sqlite ûд
	 * ʱڲԶر sqlite
	 * @return {sqlite3*}
	 */
	sqlite3* get_conn(void) const
	{
		return db_;
	}

	/**
	 * ׼α
	 * @param cursor {sqlite_cursor&}
	 * @return {bool}
	 */
	bool prepare(sqlite_cursor& cursor);

	/**
	 * ִһǲѯ̣򽫲ѯĲ
	 * @param cursor {sqlite_cursor&}
	 * @return {bool}
	 */
	bool next(sqlite_cursor& cursor, bool* done);

	/********************************************************************/
	/*            ΪһЩ sqlite3 ˽нӿ                         */
	/********************************************************************/

	/**
	 * zSqlʼΪ prepared statement
	 * @param  {const char *zSql} utf-8sql
	 * @param  {int nByte} zSqlֽڳ
	 * @param  {sqlite3_stmt **ppStmt} OUT: prepared statement
	 * @param  {const char **pzTail} OUT: ָzSqlδʹòֵָ
	 * @return {int} ɹ SQLITE_OK򷵻ӦĴ
	 */
	int sqlite3_prepare_v2(const char *zSql,
		int nByte, sqlite3_stmt **ppStmt, const char **pzTail);

	/**
	 *  prepared statement
	 * @param {sqlite3_stmt *stmt} prepared statement
	 * @return {int}  SQLITE_BUSY, SQLITE_DONE, SQLITE_ROW,
	 *          SQLITE_ERROR,  SQLITE_MISUSE
	 */
	int sqlite3_step(sqlite3_stmt *stmt);

	/**
	 * prepared statementΪʼ״̬
	 * @param {sqlite3_stmt *pStmt} prepared statement
	 * @return {int} SQLITE_ROW, SQLITE_DONE  SQLITE_OK
	 */
	int sqlite3_reset(sqlite3_stmt *pStmt);

	/**
	 * ͷ prepared statement Դ
	 * @param  {sqlite3_stmt *stmt} prepared statement
	 * @return {int} SQLITE_OK 
	 */
	int sqlite3_finalize(sqlite3_stmt *pStmt);

	/**
	 * 󶨶
	 * @param {sqlite3 *stmt} prepared statement
	 * @param {int iCol} 󶨵sqlеĲ
	 * @param {const void *value} 󶨵sqlеĲֵ
	 * @param {int n} ֽڳ
	 * @param {void(*)(void*)} 
	 * @return {int} ɹ SQLITE_OK򷵻ӦĴ
	 */
	int sqlite3_bind_blob(sqlite3_stmt *stmt, int iCol,
		const void *value, int n, void(*)(void*));

	/**
	 * int
	 * @param {sqlite3 *stmt} prepared statement
	 * @param {int iCol} 󶨵sqlеĲ
	 * @param {int value} 󶨵sqlеĲֵ
	 * @return {int} ɹ SQLITE_OK򷵻ӦĴ
	 */
	int sqlite3_bind_int(sqlite3_stmt *stmt, int iCol, int value);

	/**
	 * int64
	 * @param {sqlite3 *stmt} prepared statement
	 * @param {int iCol} 󶨵sqlеĲ
	 * @param {int64_t value} 󶨵sqlеĲֵ
	 * @return {int} ɹ SQLITE_OK򷵻ӦĴ
	 */
	int sqlite3_bind_int64(sqlite3_stmt*, int iCol, int64_t value);

	/**
	 * text
	 * @param {sqlite3 *stmt} prepared statement
	 * @param {int iCol} 󶨵sqlеĲ
	 * @param {const void *value} 󶨵sqlеĲֵ
	 * @param {int n} ֽڳ
	 * @param {void(*)(void*)} 
	 * @return {int} ɹ SQLITE_OK򷵻ӦĴ
	 */
	int sqlite3_bind_text(sqlite3_stmt *stmt, int iCol,
		const char *value, int n, void(*)(void*));

	/**
	 *  prepared statement 
	 * @param {sqlite3_stmt* pStmt} prepared statement
	 * @return {int} 
	 */
	int sqlite3_column_count(sqlite3_stmt *pStmt);

	/**
	 * زѯĶӦеĶƽϢ
	 * @param {sqlite3_stmt *stmt} prepared statement
	 * @param {int iCol} 
	 * @return {const void *} ָ
	 */
	const void *sqlite3_column_blob(sqlite3_stmt *stmt, int iCol);

	/**
	 * زѯĶӦеintϢ
	 * @param {sqlite3_stmt *stmt} prepared statement
	 * @param {int iCol} 
	 * @return {int} 
	 */
	int sqlite3_column_int(sqlite3_stmt*, int iCol);

	/**
	 * زѯĶӦеint64Ϣ
	 * @param {sqlite3_stmt *stmt} prepared statement
	 * @param {int iCol} 
	 * @return {int64_t} 
	 */
	int64_t sqlite3_column_int64(sqlite3_stmt*, int iCol);

	/**
	 * زѯĶӦе utf-8 text Ϣ
	 * @param {sqlite3_stmt *stmt} prepared statement
	 * @param {int iCol} 
	 * @return {const unsigned char *} ָ
	 */
	const unsigned char *sqlite3_column_text(sqlite3_stmt*, int iCol);

	/**
	 * زѯĶӦеĽϢֽڳ
	 * @param {sqlite3_stmt *stmt} prepared statement
	 * @param {int iCol} 
	 * @return {const unsigned char *} ָ
	 */
	int sqlite3_column_bytes(sqlite3_stmt*, int iCol);

	/**
	 * selectضе
	 * @param {sqlite3_stmt* stmt} prepared statement
	 * @param {int iCol} 
	 * @return {const char*} 
	 */
	const char *sqlite3_column_name(sqlite3_stmt *stmt, int iCol);

	/**
	 * ִеsql
	 * @param  {const char *sql} ִеsql
	 * @param  {int (*callback)(void*,int,char**,char**)} callback
	 * @param  {void *arg}callbackĵһ
	 * @param  {char **errmsg} Ϣ
	 * @return {int} SQLITE_OK 
	 */
	int sqlite3_exec(const char *sql,
		int(*callback)(void*,int,char**,char**), void *arg, char **errmsg);

	/**
	 * Ϊͷ errmsg ӵĽӿ
	 * @param {void* ptr} ͷָ
	 * @return {void}
	 */
	void sqlite3_free(void* ptr);

	/********************************************************************/
	/*            Ϊ db_handle ӿ                         */
	/********************************************************************/

	/**
	 * @override
	 */
	const char* dbtype(void) const;

	/**
	 * @override
	 */
	int get_errno(void) const;

	/**
	 * @override
	 */
	const char* get_error(void) const;

	/**
	 * @override
	 */
	bool dbopen(const char* charset = NULL);

	/**
	 * @override
	 */
	bool is_opened(void) const;

	/**
	 * @override
	 */
	bool close(void);

	/**
	 * @override
	 */
	bool tbl_exists(const char* tbl_name);

	/**
	 * @override
	 */
	bool sql_select(const char* sql, db_rows* result = NULL);

	/**
	 * @override
	 */
	bool sql_update(const char* sql);

	/**
	 * @override
	 */
	int affect_count(void) const;

	/**
	 * @override
	 */
	bool begin_transaction(void);

	/**
	 * @override
	 */
	bool commit(void);

	/**
	 * @override
	 */
	bool set_busy_timeout(int nMillisecs);


private:
	// sqlite 
	sqlite3* db_;

	// ݴ洢ļ
	string dbfile_;

	// ַת
	charset_conv* conv_;

	// ַ
	string charset_;

	// ִSQLѯĺ
	bool exec_sql(const char* sql, db_rows* result = NULL);
};

} // namespace acl

#endif // !defined(ACL_DB_DISABLE)
